// Code generated by mockery v2.27.1. DO NOT EDIT.

package sckbench

import mock "github.com/stretchr/testify/mock"

// mockConn is an autogenerated mock type for the conn type
type mockConn struct {
	mock.Mock
}

type mockConn_Expecter struct {
	mock *mock.Mock
}

func (_m *mockConn) EXPECT() *mockConn_Expecter {
	return &mockConn_Expecter{mock: &_m.Mock}
}

// Close provides a mock function with given fields:
func (_m *mockConn) Close() error {
	ret := _m.Called()

	var r0 error
	if rf, ok := ret.Get(0).(func() error); ok {
		r0 = rf()
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// mockConn_Close_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'Close'
type mockConn_Close_Call struct {
	*mock.Call
}

// Close is a helper method to define mock.On call
func (_e *mockConn_Expecter) Close() *mockConn_Close_Call {
	return &mockConn_Close_Call{Call: _e.mock.On("Close")}
}

func (_c *mockConn_Close_Call) Run(run func()) *mockConn_Close_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run()
	})
	return _c
}

func (_c *mockConn_Close_Call) Return(_a0 error) *mockConn_Close_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *mockConn_Close_Call) RunAndReturn(run func() error) *mockConn_Close_Call {
	_c.Call.Return(run)
	return _c
}

// Read provides a mock function with given fields: p
func (_m *mockConn) Read(p []byte) (int, error) {
	ret := _m.Called(p)

	var r0 int
	var r1 error
	if rf, ok := ret.Get(0).(func([]byte) (int, error)); ok {
		return rf(p)
	}
	if rf, ok := ret.Get(0).(func([]byte) int); ok {
		r0 = rf(p)
	} else {
		r0 = ret.Get(0).(int)
	}

	if rf, ok := ret.Get(1).(func([]byte) error); ok {
		r1 = rf(p)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// mockConn_Read_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'Read'
type mockConn_Read_Call struct {
	*mock.Call
}

// Read is a helper method to define mock.On call
//   - p []byte
func (_e *mockConn_Expecter) Read(p interface{}) *mockConn_Read_Call {
	return &mockConn_Read_Call{Call: _e.mock.On("Read", p)}
}

func (_c *mockConn_Read_Call) Run(run func(p []byte)) *mockConn_Read_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].([]byte))
	})
	return _c
}

func (_c *mockConn_Read_Call) Return(n int, err error) *mockConn_Read_Call {
	_c.Call.Return(n, err)
	return _c
}

func (_c *mockConn_Read_Call) RunAndReturn(run func([]byte) (int, error)) *mockConn_Read_Call {
	_c.Call.Return(run)
	return _c
}

// Write provides a mock function with given fields: p
func (_m *mockConn) Write(p []byte) (int, error) {
	ret := _m.Called(p)

	var r0 int
	var r1 error
	if rf, ok := ret.Get(0).(func([]byte) (int, error)); ok {
		return rf(p)
	}
	if rf, ok := ret.Get(0).(func([]byte) int); ok {
		r0 = rf(p)
	} else {
		r0 = ret.Get(0).(int)
	}

	if rf, ok := ret.Get(1).(func([]byte) error); ok {
		r1 = rf(p)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// mockConn_Write_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'Write'
type mockConn_Write_Call struct {
	*mock.Call
}

// Write is a helper method to define mock.On call
//   - p []byte
func (_e *mockConn_Expecter) Write(p interface{}) *mockConn_Write_Call {
	return &mockConn_Write_Call{Call: _e.mock.On("Write", p)}
}

func (_c *mockConn_Write_Call) Run(run func(p []byte)) *mockConn_Write_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].([]byte))
	})
	return _c
}

func (_c *mockConn_Write_Call) Return(n int, err error) *mockConn_Write_Call {
	_c.Call.Return(n, err)
	return _c
}

func (_c *mockConn_Write_Call) RunAndReturn(run func([]byte) (int, error)) *mockConn_Write_Call {
	_c.Call.Return(run)
	return _c
}

type mockConstructorTestingTnewMockConn interface {
	mock.TestingT
	Cleanup(func())
}

// newMockConn creates a new instance of mockConn. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func newMockConn(t mockConstructorTestingTnewMockConn) *mockConn {
	mock := &mockConn{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
